/*
 * ValuePrinterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_PRINTER_ABSTRACTION_HPP_
#define _VALUE_PRINTER_ABSTRACTION_HPP_

#include <abstraction/NaryOperationAbstraction.hpp>

namespace abstraction {

template < class ParamType >
class ValuePrinterAbstraction : public NaryOperationAbstraction < void, ParamType > {
	std::ostream & m_ostream;

public:
	ValuePrinterAbstraction ( std::ostream & os ) : m_ostream ( os ) {
	}

	bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->getParams ( ) );
		m_ostream << retrieveValue < const ParamType & > ( param.first, param.second ) << std::endl;
		return true;
	}
};

template < >
class ValuePrinterAbstraction < void > : public NaryOperationAbstraction < void > {
public:
	ValuePrinterAbstraction ( std::ostream & ) {
	}

	bool run ( ) override {
		return true;
	}
};

} /* namespace abstraction */

#endif /* _VALUE_PRINTER_ABSTRACTION_HPP_ */
